﻿namespace ProjectSportCar;

/// <summary>
/// Форма работы с объектом "Спортивный автомобиль"
/// </summary>
public partial class FormSportCar : Form
{
	/// <summary>
	/// Поле-объект для прорисовки объекта
	/// </summary>
	private DrawningSportCar? _drawningSportCar;

	/// <summary>
	/// Конструктор формы
	/// </summary>
	public FormSportCar()
	{
		InitializeComponent();
	}

	/// <summary>
	/// Метод прорисовки машины
	/// </summary>
	private void Draw()
	{
		if (_drawningSportCar == null)
		{
			return;
		}

		Bitmap bmp = new(pictureBoxSportCar.Width, pictureBoxSportCar.Height);
		Graphics gr = Graphics.FromImage(bmp);
		_drawningSportCar.DrawTransport(gr);
		pictureBoxSportCar.Image = bmp;
	}

	/// <summary>
	/// Обработка нажатия кнопки "Создать"
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	private void ButtonCreateSportCar_Click(object sender, EventArgs e)
	{
		Random random = new();
		_drawningSportCar = new DrawningSportCar();
		_drawningSportCar.Init(random.Next(100, 300), random.Next(1000, 3000),
			Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
			Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
			Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
		_drawningSportCar.SetPictureSize(pictureBoxSportCar.Width, pictureBoxSportCar.Height);
		_drawningSportCar.SetPosition(random.Next(10, 100), random.Next(10, 100));
		Draw();
	}

	/// <summary>
	/// Перемешение объекта по форме (нажатие кнопок навигации)
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	private void ButtonMove_Click(object sender, EventArgs e)
	{
		if (_drawningSportCar == null)
		{
			return;
		}

		string name = ((Button)sender)?.Name ?? string.Empty;
		bool result = false;
		switch (name)
		{
			case "buttonUp":
				result = _drawningSportCar.MoveTransport(DirectionType.Up);
				break;
			case "buttonDown":
				result = _drawningSportCar.MoveTransport(DirectionType.Down);
				break;
			case "buttonLeft":
				result = _drawningSportCar.MoveTransport(DirectionType.Left);
				break;
			case "buttonRight":
				result = _drawningSportCar.MoveTransport(DirectionType.Right);
				break;
		}

		if (result)
		{
			Draw();
		}
	}
}